/*
 * NEC Mobile Gear header file
 *
 * Copyright (c) 1998 Shin Takemura all rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 3. The name of the author may not be used to endorse or promote 
 *    products derived from this software without specific prior written 
 *    permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE REGENTS AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 *
 * $Id: necmg.h,v 1.1.4.2 1998/12/22 08:28:00 nakagawa Exp $
 *
 */
#define NECMG_COM1	1
#define NECMG_COM2	2
#define NECMG_COM3	3
#define NECMG_COM4	4
#define NECMG_IO_COM1	0x3f8
#define NECMG_IO_COM3	0x3e8

#ifdef KERNBASE
/* We need these header files.
 * #include <vm/vm.h>
 * #include <vm/vm_param.h>
 * #include <vm/pmap.h>
 */
#define NECMG_PA_TO_VA(pa)	(KERNBASE + (pa))
#define NECMG_FRAMEBUFFER	((unsigned char*)NECMG_PA_TO_VA(0xB0000))
#endif
#define NECMG_FB_SIZE 0x10000
#define NECMG_WHITE     0x00
#define NECMG_LIGHTGRAY 0x55
#define NECMG_DARKGRAY  0xaa
#define NECMG_BLACK     0xff

#define NECMG_ICON8x8_NONE 0
#define NECMG_ICON8x8_NUM  1
#define NECMG_ICON8x8_CAPS 2
#define NECMG_ICON8x8_KANA 3
#define NECMG_ICON8x8_ZOOM 4
#define NECMG_ICON8x8_SCRL 5

struct necmg_font_s {
  unsigned char *data;
  int width, height, nchars;
};
extern struct necmg_font_s necmg_fonts[];

void necmg_apm_init __P((void));
int necmg_apm_int __P((u_long *eax, u_long *ebx, u_long *ecx));
int necmg_set_contrast(int high_low);
void necmg_draw_char(int x, int y, int code, int atr, int size);
int necmg_com_power(int port, int on);
void necmg_cpu_poweroff(int howto, void *dummy_arg);
struct slot;
int necmg_pccard_enabler(struct slot *sp);

void necmg_cons_update(int xsize, int ysize, 
		       unsigned short *vvram, int start, int end);
void necmg_cons_clear(void);
int necmg_cons_get_zoompos(void);
int necmg_cons_set_zoompos(int xsize, int ysize, unsigned short *vvram, int y);

void necmg_draw_icon(int x, int y, unsigned char *icon,
		  int width, int height,
		  unsigned char fore,  unsigned char back);

extern unsigned char necmg_icon16x8[][32];
extern unsigned char necmg_icon8x8[][16];
extern unsigned char *necmg_fontrom_base;
extern int necmg_pccard_enabled;
